<template>
  <!--行政处罚强制执行申请书-->
  <el-main>
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-form-item label="文号" :label-width="formLabelWidth">
        <el-input v-model="form.unitName" placeholder="_______强执申〔    〕第    号"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="法院名 " :label-width="formLabelWidth">
            <el-input v-model="form.courtName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="申请执行人 " :label-width="formLabelWidth">
            <el-input
              v-model="form.applicationExecutor"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="申请执行人地址 " :label-width="formLabelWidth">
        <el-input v-model="form.applyAddress" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="法定代表人 " :label-width="formLabelWidth">
            <el-input v-model="form.legalName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话 " :label-width="formLabelWidth">
            <el-input v-model="form.legalPhone" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="被申请执行人 " :label-width="formLabelWidth">
            <el-input
              v-model="form.respondentName"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="法定代表人 " :label-width="formLabelWidth">
            <el-input
              v-model="form.respondentLegalName"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="被申请人地址 " :label-width="formLabelWidth">
        <el-input
          v-model="form.respondentAddress"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="作出决定日期 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.decideDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="作出决定文书 " :label-width="formLabelWidth">
            <el-input v-model="form.behavior" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="决定书文号 " :label-width="formLabelWidth">
            <el-input v-model="form.decideUnitName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="催告书时间 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.reminderDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="催告书文号 " :label-width="formLabelWidth">
            <el-input v-model="form.reminderUnitName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="联系人 " :label-width="formLabelWidth">
            <el-input v-model="form.contactsName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话 " :label-width="formLabelWidth">
            <el-input v-model="form.contactsPhone" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="印章日期 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.executionTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
  import {getObj, saveObj} from "@/api/News/constraintExecute";
  import WordView from "@/views/News/word-view";
  import moment from "moment";

  export default {
    name: "constraint_execute",
    props: ['isShowYulan', 'id', 'isFinish', 'processId'],
    components: {
      WordView
    },
    data() {
      return {
        showView: false,
        form: {
          unitName: "",
          courtName: "",
          applicationExecutor: "",
          applyAddress: "",
          legalName: "",
          legalPhone: "",
          respondentName: "",
          respondentLegalName: "",
          respondentAddress: "",
          decideDate: '',
          decideUnitName: '',
          reminderUnitName: '',
          contactsName: '',
          contactsPhone: '',
          executionTime: '',
          behavior: ''
        },
        formLabelWidth: "140px",
      };
    },
    created() {
      this.init()
    },
    methods: {
      init() {
        getObj(this.id).then((res) => {
          if (res.data.code == 0) {
            // 转换null为""
            let v = res.data.data;
            for (let attr in v) {
              if (v[attr] == null) {
                v[attr] = "";
              }
            }
            let str = JSON.stringify(v);
            let data = JSON.parse(str);
            this.form = data;
          }
        });
      },
      dataFormSubmit(type) {
        console.log(type)
        this.$refs['form'].validate((valid) => {
          if (valid) {
            let obj = this;
            if ("1" == type) {
              this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
                confirmButtonText: '是',
                cancelButtonText: '否',
                type: 'warning'
              }).then(function () {
                obj.form.registerState = type;
                obj.form.registerId = obj.id;
                obj.form.processId = obj.processId;
                saveObj(obj.form).then((res) => {
                  // this.submitLoading = false;
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                })
              })
            } else {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              })
            }
          }
        })
      },
      cancel() {
        this.$emit('cancel', false);
      },
      cancelWord() {
        this.showView = false;
      },
      viewVord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
        //格式转换
        let wordData = this.transforData(data);
        //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
        this.showView = true;
        this.$nextTick(() => {
          this.$refs.wordInfo.init(wordData, "/wordes/constraintExecute.docx");
        })
      },
      downloadWord(data) {
        if(data.registerState == null || data.registerState == ""){
          //预览前先进行保存
          data.registerState = '0';
          data.registerId = this.id;
          data.processId = this.processId;
          saveObj(data).then((res) => {
          })
        }
        let wordData = this.transforData(data);
        WordView.methods.exportDoc(wordData, "/wordes/constraintExecute.docx", "行政处罚强制执行申请书.docx");
      },
      transforData(obj) {
        let s = JSON.stringify(obj);
        let data = JSON.parse(s);
        if (data.decideDate != '' && data.decideDate != null) {
          data.decideDate = moment(data.decideDate).format('YYYY年MM月DD日');
        } else {
          data.decideDate = '  年  月  日'
        }

        if (data.reminderDate != '' && data.reminderDate != null) {
          data.reminderDate = moment(data.reminderDate).format('YYYY年MM月DD日');
        } else {
          data.reminderDate = '  年  月  日'
        }

        if (data.executionTime != '' && data.executionTime != null) {
          data.executionTime = moment(data.executionTime).format('YYYY年MM月DD日');
        } else {
          data.executionTime = '  年  月  日'
        }

        return data;
      }
    }
  }
</script>

<style scoped>

</style>
